Bug 202330 - dia provided libdia has many of "undefined symbol"
dia provided libdia has many of "undefined symbol"
Product: Fedora
Classification: Fedora
Component: dia (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Hans de Goede
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2006-08-12 18:02 EDT by Michal Jaegermann
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2006-08-13 18:31:54 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Michal Jaegermann 2006-08-12 18:02:29 EDT
Description of problem:

After 'ldd -d -r dia/libdia.so' there is 478 of "undefined symbol"
messages.  It looks like that bulk of these missing symbols is
provided by libglib and libgtk.

"The libraries work, but less efficiently than they could if they
were linked properly".

Version-Release number of selected component (if applicable):
Comment 1 Hans de Goede 2006-08-13 17:49:29 EDT

I'm working on a fix for this for libdia.so

However the other.so files in %{_libdir}/dia also have weak symbols / non
complete linking. I don't know if this is a problem here since these are plugins
which gets opened with dlopen, not linked in.

Jakub can you help here, is adding all needed libs to the linking of the .so
beneficial if the resulting .so will only get dlopened? (Assuming this can be
done at all, the .so could need symbols from the app doing the dlopen itself).

Comment 2 Jakub Jelinek 2006-08-13 17:58:13 EDT
It depends.  If the symbols are versioned, then it is desirable to link against
the libraries that provide the versioned symbols.  Otherwise, for plugins there
is no special benefit, appart from guaranteeing that all the dependencies
needed for the plugin will be loaded.  But if you (or the API of the framework
that provides the plugin) reasoanbly guarantee that the dependencies are already
loaded by the main program or some of its dependencies, then plugins don't need
to satisfy -Wl,-z,defs checks.
Comment 3 Hans de Goede 2006-08-13 18:31:54 EDT

Thanks for the info.

A new version (0.95-6) with the weak symbols in libdia.so fixed should show up
on a mirror near you soon.

Note You need to log in before you can comment on or make changes to this bug.